//+------------------------------------------------------------------+
//|                                             ForexFactoryNews.mq4 |
//|                                      Copyright  2010, komposter |
//|                                       mailto:komposter@gmail.com |
//|                            Kaur (kaur.opentraders.ru) |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, komposter"
#property link      "mailto:komposter@gmail.com"

/*
  Kaur:
 -     ;
 -          1 ()  3 () ;
 -  TimeShift_Local  ;
 -       60   30;
 -      13  10;
*/

/*
ToDo:
 -  
 -    
 - 
 -   ?
*/

extern string	FFN_Main						= "-----------------Main----------------";
extern int		RefreshInterval_ms		= 1000;												//   ()
extern int		PauseBetweenDownloads	= 30;													//        ()
extern int		TimeShift_MT				= 1;													//   
extern int		TimeShift_Local			= 3;													//   

extern string	FFN_Filtrs					= "----------------Filtrs---------------";
extern string	FiltrSymbols				= "AUD,CAD,CHF,CNY,EUR,GBP,JPY,NZD,USD";  //   ("" -  , "a" -     ())
extern string	FiltrImpact					= "N,L,M,H";										//   ("" -  )

extern string	FFN_ImpactColors			= "------------Impact Colors------------";
extern color	Impact_NonEconomic		= White;												//   
extern color	Impact_Low					= Yellow;											//    
extern color	Impact_Medium				= Orange;											//    
extern color	Impact_High					= Red;												//    

extern string	FFN_Table					= "----------------Table----------------";
extern double	Table_RowHeight			= 10.0;												//   ()
extern string	Table_Font					= "Terminal bold";								// 
extern double	Table_FontSize				= 7.0;												//  
extern int		Table_MaxDescription		= 27;													//     ()

extern string	FFN_TableColors			= "-------------Table Colors------------";
extern color	Table_ColorMain			= LightGray;										//  
extern color	Table_ColorOld				= Gray;												//   
extern color	Table_ColorBetter			= Green; // Lime;									//  ,   ,   ,    
extern color	Table_ColorWorse			= Maroon; // Red;									//  ,   ,   ,    

extern string	FFN_Lines					= "----------------Lines----------------";
extern string	Lines_FiltrSymbols		= "a";												//     ("" -  , "a" -     ())
extern string	Lines_FiltrImpact			= "M,H";												//     ("" -  )
extern int		Lines_Width					= 1;													//  
extern int		Lines_Style					= STYLE_DASHDOT;									//  
extern bool		Lines_Back					= true;												// true -    


#define FIRST_WEEK 1167523200		//    ,      forexfactory.com
#define WEEK_SECONDS 604800 		// -   
#define DAY_SECONDS 86400			// -   

#define SHIFT_WINDOW_UP 5			//     
#define SHIFT_WINDOW_DN 20			//     
#define SHIFT_BUTTONS 2				//     
#define SHIFT_TABLE 18				//    

string	strInfo				= "";
int		TableRows			= 0;		// -   
int		MaxTableRows		= 0;

datetime	CurWeekUpdate		= 0;
datetime	NextNewsTime		= 0;
datetime	UpdateUpTo			= 0;
int		lastRandom			= 0;
datetime	preCurWeek			= 0;

int		NewsCount			= 0;
int		NextNews_n			= 0;
string	News					[999][10];	// date;time;currency;impact;description;Actual (<|=|>);Actual value;Forecast;Previous revision (<|=|>);Previous value

bool		AllowButton			[3] = { false, false, false };
string	ButtonsName			[3] = { "FFN_ButtonLines", "FFN_ButtonChart", "FFN_ButtonPause" };
string	ButtonsDesc			[3] = { "[LINES]", "[CHART]", "[PAUSE]" };
int		ButtonsX				[3] = { 245, 178, 115 };
int		ButtonsY					 = SHIFT_BUTTONS;

int init()
{
	if ( !IsDllsAllowed() ) Alert( " DLL ,       !" );

	if ( GlobalVariableCheck( "FFN_CurWeekUpdate"	) ) CurWeekUpdate = GlobalVariableGet( "FFN_CurWeekUpdate"	);
	if ( GlobalVariableCheck( "FFN_NextNewsTime"		) ) NextNewsTime	= GlobalVariableGet( "FFN_NextNewsTime"	);
	if ( GlobalVariableCheck( "FFN_UpdateUpTo"		) ) UpdateUpTo		= GlobalVariableGet( "FFN_UpdateUpTo"		);

	MathSrand( GetTickCount() );
	lastRandom = MathRand();

	preCurWeek = 0;

	if ( FiltrSymbols			== "a" ) FiltrSymbols			= Symbol();
	if ( Lines_FiltrSymbols == "a" ) Lines_FiltrSymbols	= Symbol();

	FindTimeShift		();
	FindWindowHeight	();
	InitButtons			();

	if ( PauseBetweenDownloads < 30 ) PauseBetweenDownloads = 30;

	start();
	return(0);
}

int deinit()
{
	obj_delete( "FFN_" );
	return(0);
}

int start()
{
	//            
	int LastTickCouunt = 0;

	while ( !IsStopped() && IsExpertEnabled() )
	{
		CheckButtons				();	//  
		if ( AllowButton[2] )			//    "",
		{
			CheckButtons			();	//  
			break;							//   
		}

		//  RefreshInterval_ms  
		if ( GetTickCount() - LastTickCouunt >= RefreshInterval_ms )
		{
			strInfo					= "";
			LastTickCouunt			= GetTickCount();

			FindWindowHeight		();	//   
			UpdateHistory			();	// ,     
			UpdateCurWeek			();	//   

			Comment		( strInfo );	//    
			WindowRedraw			();	//  
		}

		Sleep(100);							//  ,    
	}

	return(0);
}


//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
#import "kernel32.dll"
  int GetTimeZoneInformation(int& buf[]);
  int GetSystemTime(int& buf[]);
#import

void FindTimeShift()
{
	if ( IsDllsAllowed() )
	{
		// thanks for "Erics, erics.fx@tut.by"
		int st[4]; GetSystemTime(st);
		int GMThour = st[2] & 0xFFFF;

/* 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		int MT_hour = TimeHour( TimeCurrent() );
		TimeShift_MT = MT_hour - GMThour;
		if ( TimeShift_MT < -12 ) TimeShift_MT += 24;
		if ( TimeShift_MT >  12 ) TimeShift_MT -= 24;
*/

		int Local_hour = TimeHour( TimeLocal() );
		TimeShift_Local = Local_hour - GMThour;
		if ( TimeShift_Local < -12 ) TimeShift_Local += 24;
		if ( TimeShift_Local >  12 ) TimeShift_Local -= 24;
	}
	else
	{
		Print( "Using default Local TimeShift (GMT +3)..." );
		TimeShift_Local = 3;
	}
//	Print( "TimeShift (Local) = ", TimeShift_Local, ", TimeShift (MT) = ", TimeShift_MT );
}


//+------------------------------------------------------------------+
//|  -   (   )
//+------------------------------------------------------------------+
#import "user32.dll"
  bool GetWindowRect(int h, int& pos[4]);
#import

void FindWindowHeight()
{
	if ( IsDllsAllowed() )
	{
		//  
		int h = WindowHandle( Symbol(), Period() ), rect[4];
		if ( h == 0 ) return(-1);

		//  
		GetWindowRect(h, rect);
		int WindowHeight = rect[3] - rect[1];

		//          
		WindowHeight = WindowHeight - SHIFT_WINDOW_UP - SHIFT_WINDOW_DN - SHIFT_BUTTONS - SHIFT_TABLE;

		//    
		TableRows		= MathFloor( WindowHeight / Table_RowHeight );
		MaxTableRows	= MathMax( TableRows, MaxTableRows );
	}
	else
	{
		TableRows		= 30;
		MaxTableRows	= 30;
	}

//	Print( "WindowHeight = ", WindowHeight, ", TableRows = ", TableRows );
}

//  
void InitButtons()
{
	AllowButton[2] = false;

	for ( int b = 0; b < 3; b ++ )
	{
		if ( ObjectFind( ButtonsName[b] ) < 0 )
		{
			ObjectCreate( ButtonsName[b], OBJ_LABEL, 0, Time[0], Ask );
			ObjectSet	( ButtonsName[b], OBJPROP_CORNER, 1 );
			ObjectSet	( ButtonsName[b], OBJPROP_BACK, false );
			ObjectSet	( ButtonsName[b], OBJPROP_ANGLE, 0.0 );
		}

		if ( AllowButton[b] )
			ObjectSet( ButtonsName[b], OBJPROP_COLOR, Lime );
		else
			ObjectSet( ButtonsName[b], OBJPROP_COLOR, Gray );

		ObjectSet	( ButtonsName[b], OBJPROP_XDISTANCE, ButtonsX[b] );
		ObjectSet	( ButtonsName[b], OBJPROP_YDISTANCE, ButtonsY );

		if ( AllowButton[b] )
			ObjectSetText	( ButtonsName[b], ButtonsDesc[b], 8, Table_Font, Lime );
		else
			ObjectSetText	( ButtonsName[b], ButtonsDesc[b], 8, Table_Font, Gray );
	}
	GetLastError();
}


//  
void CheckButtons()
{
	bool need_redraw = false;

	for ( int b = 0; b < 3; b ++ )
	{
		if ( ObjectFind( ButtonsName[b] ) < 0 )
		{
			ObjectCreate	( ButtonsName[b], OBJ_LABEL, 0, Time[0], Ask );
			ObjectSet		( ButtonsName[b], OBJPROP_CORNER, 1 );
			ObjectSet		( ButtonsName[b], OBJPROP_BACK, false );
			ObjectSet		( ButtonsName[b], OBJPROP_ANGLE, 0.0 );
			if ( AllowButton[b] )
				ObjectSetText	( ButtonsName[b], ButtonsDesc[b], 8, Table_Font, Lime );
			else
				ObjectSetText	( ButtonsName[b], ButtonsDesc[b], 8, Table_Font, Gray );
			need_redraw = true;
		}
		else
		{
			if ( ObjectGet( ButtonsName[b], OBJPROP_XDISTANCE ) != ButtonsX[b] || ObjectGet( ButtonsName[b], OBJPROP_YDISTANCE ) != ButtonsY )
			{
				if ( ObjectDelete( ButtonsName[b] ) && ObjectFind( ButtonsName[b] ) < 0 )
				{
					need_redraw = true;
					AllowButton[b] = !AllowButton[b];
					if ( AllowButton[b] == false )
					{
						if ( b == 0 ) obj_delete( "FFN_L_" );
					}
				}
			}
		}

		if ( AllowButton[b] )
			ObjectSet( ButtonsName[b], OBJPROP_COLOR, Lime );
		else
			ObjectSet( ButtonsName[b], OBJPROP_COLOR, Gray );

		ObjectSet	( ButtonsName[b], OBJPROP_XDISTANCE, ButtonsX[b] );
		ObjectSet	( ButtonsName[b], OBJPROP_YDISTANCE, ButtonsY );

	}
	if ( need_redraw ) WindowRedraw();
	GetLastError();
}


//+------------------------------------------------------------------+
//|    
//+------------------------------------------------------------------+
bool UpdateCurWeek()
{
	//    
	datetime curCurWeek = FIRST_WEEK + MathFloor( (TimeLocal()-FIRST_WEEK) / WEEK_SECONDS ) * WEEK_SECONDS;

	//    :
	bool NeedUpdate = false, ForcedUpdate = true;
	//  -        7- ;
	if ( TimeLocal() <= UpdateUpTo )
	{
//		Print( "UpdateCurWeek(): update after news (update up to = ", TimeToStr( UpdateUpTo, TIME_DATE | TIME_SECONDS ), ")!" );
		NeedUpdate = true;
	}
	//  -      ;
	else if ( NextNewsTime > 0 && TimeLocal() >= NextNewsTime )
	{
		Print( "UpdateCurWeek(): update after news (last news time = ", TimeToStr( NextNewsTime, TIME_DATE | TIME_SECONDS ), ")!" );
		UpdateUpTo = NextNewsTime + 5*60;	//     5- 
		GlobalVariableSet( "FFN_UpdateUpTo", UpdateUpTo );
		NeedUpdate = true;
	}
	//  -    (   );
	else if ( preCurWeek <= 0 )
	{
		Print( "UpdateCurWeek(): first lounch!" );
		NeedUpdate = true;
		ForcedUpdate = false;
	}
	//  -   ;
	else if ( curCurWeek > preCurWeek )
	{
		Print( "UpdateCurWeek(): new week (pre = ", TimeToStr( preCurWeek, TIME_DATE ), ", cur = ", TimeToStr( curCurWeek, TIME_DATE ), ")!" );
		NeedUpdate = true;
	}
	//  -        (+/- 5 );
	else if ( TimeLocal() >= (CurWeekUpdate + 60*60 - 300 + lastRandom*600/32767) )
	{
		Print( "UpdateCurWeek(): new update time (prev time = ", TimeToStr( CurWeekUpdate, TIME_DATE | TIME_SECONDS ), ")!" );
		NeedUpdate = true;
	}


	//    :
	// 1.     (  ),  ()   (  ) .
	// 2.  htm   ( )  ,   csv.
	// 3.  csv  ( ),    ( )    News,   ( ALL  ,    FiltrSymbols)    (FiltrImpact).
	// 4.       (TimeShift_MT).
	if ( NeedUpdate )
	{
		if ( TimeDayOfWeek( TimeLocal() ) > 4 )
		{
			if ( !LoadWeek( curCurWeek + WEEK_SECONDS, "", false ) ) return(false);
		}
		if ( !LoadWeek( curCurWeek, "", ForcedUpdate ) ) return(false);

		NewsCount = 0;
		if ( TimeDayOfWeek( TimeLocal() ) < 2 )
		{
			if ( !LoadFileToArray( StringConcatenate( "ForexFactoryNews\\History\\", TimeToStr( curCurWeek - WEEK_SECONDS, TIME_DATE ), ".csv" ) ) ) return(false);
		}
		LoadFileToArray( StringConcatenate( "ForexFactoryNews\\", TimeToStr( curCurWeek, TIME_DATE ), ".csv" ) );
		if ( TimeDayOfWeek( TimeLocal() ) > 4 ) LoadFileToArray( StringConcatenate( "ForexFactoryNews\\", TimeToStr( curCurWeek + WEEK_SECONDS, TIME_DATE ), ".csv" ) );

		obj_delete( "FFN_L" );

		//     ,          +/- 5 .
		preCurWeek				= curCurWeek;
		CurWeekUpdate			= TimeLocal();
		lastRandom				= MathRand();
		GlobalVariableSet( "FFN_CurWeekUpdate", CurWeekUpdate );
	}


	// 5.  ,   ,  ,   :
	//     - ,  ,  ,    2- ;
	//		 -   ,           (   ,  ).
	// 6.       (     "  "  "")      .
	datetime cur_news; int MaybeNext = -1;
	for ( int n = 0; n < NewsCount; n ++ )
	{
		// hh:mm ( "All Day", "Tentative", "1st-3th", "Day 1",  .)
		if ( StringLen( News[n][1] ) == 5 && StringFind( News[n][1], ":" ) == 2 ) 
		{
			cur_news = StrToTime( StringConcatenate( News[n][0], " ", News[n][1] ) );

			if ( cur_news > TimeLocal() )
			{
/*				if ( MaybeNext >= 0 )
					NextNews_n		= MaybeNext;
				else
*/					NextNews_n		= n;

				NextNewsTime		= cur_news;

				static datetime prevNextNewsTime = 0;
				if ( NextNewsTime != prevNextNewsTime )
				{
					GlobalVariableSet( "FFN_NextNewsTime", NextNewsTime );
					prevNextNewsTime = NextNewsTime;
				}
				break;
			}
			else
			{
				MaybeNext = -1;
			}
		}
		else
		{
			if ( MaybeNext < 0 ) MaybeNext = n;
		}
	}

	int CurNews_n = 0;
	if ( NewsCount >= TableRows )
	{
		CurNews_n = NextNews_n - TableRows/3.0 + 1;
		if ( CurNews_n < 0 ) CurNews_n = 0;
	}
	else
	{
		CurNews_n = 0;
	}


	//+------------------------------------------------------------------+
	//|   
	//+------------------------------------------------------------------+
	//     ,     :
	string drawed_date = "", current_date = "";
	int max_index = MathMin( CurNews_n+TableRows, NewsCount )-1;
	for ( int r = 0; r < MaxTableRows; r ++ )
	{
		if ( CurNews_n < NewsCount && r < TableRows )
		{
			//  -      ,     (    ).
			current_date = News[CurNews_n][0];
			if ( current_date != drawed_date )
			{
				SetTableVal( r, 0, "______________________________________________________________", -1, 1 );
				SetTableVal( r, 1, "" );
				SetTableVal( r, 2, "" );
				SetTableVal( r, 3, "" );
				SetTableVal( r, 4, strDayOfWeek( StrToTime( current_date ) ) + ", " + current_date );
				SetTableVal( r, 5, "" );

				drawed_date = current_date;
			}
			else
			{
				//  - : ,  (    ), ,   (        "<|=|>").
				if ( CurNews_n >= NextNews_n )
				{
					SetTableVal( r, 0, News[CurNews_n][9], ChangeColor( News[CurNews_n][8] ) );
					SetTableVal( r, 1, News[CurNews_n][7] );
					SetTableVal( r, 2, News[CurNews_n][6], ChangeColor( News[CurNews_n][5] ) );
					SetTableVal( r, 3, News[CurNews_n][4] );
					SetTableVal( r, 4, News[CurNews_n][2], ImpactColor( News[CurNews_n][3] ) );
					SetTableVal( r, 5, News[CurNews_n][1] );
				}
				//  -     .
				else
				{
					SetTableVal( r, 0, News[CurNews_n][9], ChangeColor( News[CurNews_n][8], true ) );
					SetTableVal( r, 1, News[CurNews_n][7], Table_ColorOld );
					SetTableVal( r, 2, News[CurNews_n][6], ChangeColor( News[CurNews_n][5], true ) );
					SetTableVal( r, 3, News[CurNews_n][4], Table_ColorOld );
					SetTableVal( r, 4, News[CurNews_n][2], ImpactColor( News[CurNews_n][3], true ) );
					SetTableVal( r, 5, News[CurNews_n][1], Table_ColorOld );
				}

				//  -      UpNext.
				if ( CurNews_n == NextNews_n ) SetNext( r );

				CurNews_n ++;
			}
		}
		//  -     ,     .
		else
		{
			SetTableVal( r, 0, "" );
			SetTableVal( r, 1, "" );
			SetTableVal( r, 2, "" );
			SetTableVal( r, 3, "" );
			SetTableVal( r, 4, "" );
			SetTableVal( r, 5, "" );
		}
	}


	//+------------------------------------------------------------------+
	//|  
	//+------------------------------------------------------------------+
	// 
	if ( AllowButton[0] )
	{
		for ( n = 0; n < NewsCount; n ++ )
		{
			// hh:mm ( "All Day", "Tentative", "1st-3th", "Day 1",  .)
			if ( StringLen( News[n][1] ) == 5 && StringFind( News[n][1], ":" ) == 2 ) 
			{
				if ( SelectedSymbol_Lines( News[n][2] ) )
				{
					if ( SelectedImpact_Lines( News[n][3] ) )
					{
						string d = News[n][0], t = News[n][1];
						if ( ShiftDate_ToMT( d, t ) )
						{
							string desc = StringConcatenate( News[n][2], ": ", News[n][4] );
							if ( News[n][9] != "" ) desc = StringConcatenate( desc, " [", News[n][9], ", ", News[n][7], ", ", News[n][6], "]" );
							SetLine( n, StrToTime( StringConcatenate( d, " ", t ) ),
										desc,
										ImpactColor( News[n][3] ) );
							continue;
						}
					}
				}
			}
			ObjectDelete( "FFN_L_" + str000( n ) );
		}
	}


	return(true);
}

//      
bool LoadFileToArray( string file_name )
{
//	Print( "LoadFileToArray(", file_name, "): reading csv..." );

	int _GetLastError, file_handle = FileOpen( file_name, FILE_READ | FILE_CSV );
	if ( file_handle > 0 )
	{
		while ( !FileIsEnding( file_handle ) )
		{
			for ( int c = 0; c < 10; c ++ )
			{
				News[NewsCount][c] = FileReadString( file_handle );
				if ( News[NewsCount][0] == "" ) break;
			}
			if ( News[NewsCount][0] != "" )
			{
				if ( SelectedSymbol( News[NewsCount][2] ) )
				{
					if ( SelectedImpact( News[NewsCount][3] ) )
					{
						if ( ShiftDate() )
						{
							NewsCount ++;
						}
					}
				}
			}
		}
		FileClose( file_handle );
		return(true);
	}
	else
	{
		_GetLastError = GetLastError();
//		Print( "LoadFileToArray() - FileOpen() Error #", _GetLastError, "!" );
		return(false);
	}
}

//  true,       
bool SelectedSymbol( string symbol )
{
	if ( FiltrSymbols == "" )								return(true);
	if ( symbol == "ALL" )									return(true);
	if ( StringFind( FiltrSymbols, symbol ) >= 0 )	return(true);

	return(false);
}

//  true,       
bool SelectedImpact( string impact )
{
	if ( FiltrImpact == "" )								return(true);
	if ( StringFind( FiltrImpact, impact ) >= 0 )	return(true);

	return(false);
}

//  true,       
bool SelectedSymbol_Lines( string symbol )
{
	if ( Lines_FiltrSymbols == "" )								return(true);
	if ( symbol == "ALL" )											return(true);
	if ( StringFind( Lines_FiltrSymbols, symbol ) >= 0 )	return(true);

	return(false);
}

//  true,       
bool SelectedImpact_Lines( string impact )
{
	if ( Lines_FiltrImpact == "" )								return(true);
	if ( StringFind( Lines_FiltrImpact, impact ) >= 0 )	return(true);

	return(false);
}

//       
bool ShiftDate()
{
	if ( StringLen( News[NewsCount][1] ) == 5 && StringFind( News[NewsCount][1], ":" ) == 2 )
	{
		datetime shifted_date = StrToTime( StringConcatenate( News[NewsCount][0], " ", News[NewsCount][1] ) ) + 5*60*60 + TimeShift_Local*60*60;

		News[NewsCount][0] = TimeToStr( shifted_date, TIME_DATE );
		News[NewsCount][1] = TimeToStr( shifted_date, TIME_MINUTES );

		return(true);
	}
	else
	{
		if ( NewsCount > 0 )
		{
			if ( StrToTime( News[NewsCount-1][0] ) > StrToTime( News[NewsCount][0] ) ) News[NewsCount][0] = News[NewsCount-1][0];
		}
		return(true);
	}
}

bool ShiftDate_ToMT( string& date, string& time )
{
	datetime shifted_date = StrToTime( StringConcatenate( date, " ", time ) ) - TimeShift_Local*60*60 + TimeShift_MT*60*60;

	date = TimeToStr( shifted_date, TIME_DATE );
	time = TimeToStr( shifted_date, TIME_MINUTES );

	return(true);
}

string strDayOfWeek( datetime date )
{
	switch( TimeDayOfWeek( date ) )
	{
		case 0: return( "" );
		case 1: return( "" );
		case 2: return( "" );
		case 3: return( "" );
		case 4: return( "" );
		case 5: return( "" );
		case 6: return( "" );
		default: return( "Invalid date!" );
	}
}

color ChangeColor( string change_str, bool old = false )
{
	if ( change_str == ">" ) return( Table_ColorBetter );
	if ( change_str == "<" ) return( Table_ColorWorse );

	if ( !old )
		return( Table_ColorMain );
	else
		return( Table_ColorOld );
}

color ImpactColor( string impact_str, bool old = false )
{
	if ( impact_str == "H" ) return( Impact_High );
	if ( impact_str == "M" ) return( Impact_Medium );
	if ( impact_str == "L" ) return( Impact_Low );
	return( Impact_NonEconomic );
}


//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void SetTableVal( int row, int col, string text, color custom_color = -1, int custom_y_shift = 0 )
{
	string name = StringConcatenate( "FFN_T_", str00( row ), "_", col );

	int columns_width[6] = { 34, 34, 34, 138, 28, 28 };

	int x = 5;
	for ( int c = 0; c < col; c ++ ) x += columns_width[c];

	int y = SHIFT_BUTTONS + SHIFT_TABLE + row*Table_RowHeight + custom_y_shift;

	if ( col == 3 )
	{
		if ( StringLen( text ) > Table_MaxDescription ) text = StringSubstr( text, 0, Table_MaxDescription-3 ) + "...";
	}

	color use_color = Table_ColorMain;
	if ( custom_color != -1 ) use_color = custom_color;

	if ( ObjectFind( name ) < 0 )
	{
		ObjectCreate( name, OBJ_LABEL, 0, Time[0], Ask );
		ObjectSet	( name, OBJPROP_CORNER, 1 );
		ObjectSet	( name, OBJPROP_BACK, false );
		ObjectSet	( name, OBJPROP_ANGLE, 0.0 );
	}

	ObjectSet	( name, OBJPROP_COLOR, use_color );
	ObjectSet	( name, OBJPROP_XDISTANCE, x );
	ObjectSet	( name, OBJPROP_YDISTANCE, y );

	ObjectSetText( name, text, Table_FontSize, Table_Font, use_color );
	GetLastError();
}

void SetNext( int row )
{
	string name = "FFN_UpNext!";

	int x = 300;
	int y = SHIFT_BUTTONS + SHIFT_TABLE + row*Table_RowHeight;

	if ( ObjectFind( name ) < 0 )
	{
		ObjectCreate( name, OBJ_LABEL, 0, Time[0], Ask );
		ObjectSet	( name, OBJPROP_CORNER, 1 );
		ObjectSet	( name, OBJPROP_BACK, false );
		ObjectSet	( name, OBJPROP_ANGLE, 0.0 );
	}

	ObjectSet	( name, OBJPROP_COLOR, Lime );
	ObjectSet	( name, OBJPROP_XDISTANCE, x );
	ObjectSet	( name, OBJPROP_YDISTANCE, y );

	ObjectSetText( name, "", Table_FontSize+1, "Wingdings", Lime );
	GetLastError();
}

void SetLine( int n, datetime date, string description, color use_color )
{
	string name = "FFN_L_" + str000( n );

	if ( ObjectFind( name ) < 0 )
	{
		ObjectCreate( name, OBJ_VLINE, 0, date, Ask );
		ObjectSet	( name, OBJPROP_WIDTH, Lines_Width );
		ObjectSet	( name, OBJPROP_STYLE, Lines_Style );
		ObjectSet	( name, OBJPROP_BACK, Lines_Back );
	}

	ObjectSet	( name, OBJPROP_TIME1, date );
	ObjectSet	( name, OBJPROP_COLOR, use_color );

	ObjectSetText( name, description, 7, "Arial", Black );
	GetLastError();
}

string str00( string str )
{
	if ( StringLen( str ) < 2 ) return( StringConcatenate( "0", str ) );
	return(str);
}

string str000( string str )
{
	while ( StringLen( str ) < 3 ) str = StringConcatenate( "0", str );
	return(str);
}


//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
bool UpdateHistory()
{
	// 
	datetime	LastLoadedWeek		= 0;
	int _GetLastError, file_handle = FileOpen( "ForexFactoryNews\\History\\!LastLoadedWeek.csv", FILE_READ | FILE_CSV );
	if ( file_handle > 0 )
	{
		LastLoadedWeek = StrToTime( FileReadString( file_handle ) );
		FileClose( file_handle );
	}
	else
	{
		_GetLastError = GetLastError();
		if ( _GetLastError == 4103 )
		{
			LastLoadedWeek = 0;
		}
		else
		{
			Print( "UpdateHistory() - FileOpen() Error #", _GetLastError, "!" );
			return(false);
		}
	}

	//    
	int StartWeek = FIRST_WEEK;
	if ( LastLoadedWeek > 0 ) StartWeek = LastLoadedWeek + WEEK_SECONDS;

	//        ()
	for ( int CurWeek = StartWeek; CurWeek < (TimeLocal()-WEEK_SECONDS); CurWeek += WEEK_SECONDS )
	{
		if ( LoadWeek( CurWeek ) )
			LastLoadedWeek = CurWeek;
		else
			break;
	}

	//     
	file_handle = FileOpen( "ForexFactoryNews\\History\\!LastLoadedWeek.csv", FILE_WRITE | FILE_CSV );
	if ( file_handle > 0 )
	{
		//    
		if ( FileWrite( file_handle, TimeToStr( LastLoadedWeek, TIME_DATE ) ) < 0 )
		{
			//   ,  
			_GetLastError = GetLastError();
			Print( "UpdateHistory() - FileWrite() Error #", _GetLastError, "!" );
		}
		FileClose( file_handle );
	}
	else
	{
		//    
		_GetLastError = GetLastError();
		Print( "UpdateHistory() - FileOpen() Error #", _GetLastError, "!" );
		return(false);
	}

	return(true);
}


//+------------------------------------------------------------------+
//|    
//+------------------------------------------------------------------+
bool LoadWeek( datetime WeekTime, string Dir = "History\\", bool forced = false )
{
	int		_GetLastError	= 0;
	int		file_handle		= -1;
	string	strWeekTime		= TimeToStr( WeekTime, TIME_DATE );
	string	strURL			= StringConcatenate( "http://www.forexfactory.com/calendar.php?c=2&week=", WeekTime, "&do=displayweek&month=", TimeMonth( WeekTime ), "&year=", TimeYear( WeekTime ) );
	string	FileName			= "ForexFactoryNews\\" + Dir + strWeekTime;
	string	strHTM			= "";
	string	strCSV			= "";

	if ( !forced )
	{
		file_handle = FileOpen( FileName + ".csv", FILE_READ | FILE_CSV );
		if ( file_handle > 0 )
		{
			Print( "LoadWeek(", strWeekTime, "): already loaded and converted!" );
			FileClose( file_handle );
			return(true);
		}
		
		file_handle = FileOpen( FileName + ".htm", FILE_READ | FILE_CSV );
	}
	else
	{
		file_handle = 0;
	}

	if ( file_handle > 0 )
	{
		FileClose( file_handle );
	}
	else
	{
		if ( !IsDllsAllowed() ) return(false);

		datetime LastLoadingTime = GlobalVariableGet( "FFN_LastLoadingTime" );
		if ( TimeLocal() - LastLoadingTime < PauseBetweenDownloads )
		{
			strInfo = StringConcatenate( strInfo, "Next download will be available after ", ((LastLoadingTime + PauseBetweenDownloads) - TimeLocal()), " seconds (", TimeToStr( LastLoadingTime + PauseBetweenDownloads, TIME_SECONDS ), ")...", "\n" );
			return(false);
		}
		GlobalVariableSet( "FFN_LastLoadingTime", TimeLocal() );

		Print( "LoadWeek(", strWeekTime, "): loading..." );
		if ( !GrabWeb( strURL, strHTM ) )
		{
			Print( "LoadWeek(", strWeekTime, "): loading error!" );
			return(false);
		}

		Print( "LoadWeek(", strWeekTime, "): writing htm..." );
		file_handle = FileOpen( FileName + ".htm", FILE_WRITE | FILE_CSV );
		if ( file_handle > 0 )
		{
			FileWrite( file_handle, strHTM );
			FileClose( file_handle );
		}
	}

	strHTM = "";
	file_handle = FileOpen( FileName + ".htm", FILE_READ | FILE_CSV );
	if ( file_handle > 0 )
	{
		Print( "LoadWeek(", strWeekTime, "): reading htm..." );
		while ( !FileIsEnding( file_handle ) )
		{
			strHTM = StringConcatenate( strHTM, FileReadString( file_handle ) );
		}
		FileClose( file_handle );
	}
	else
	{
		_GetLastError = GetLastError();
		Print( "LoadWeek() - FileOpen() Error #", _GetLastError, "!" );
		return(false);
	}

	Print( "LoadWeek(", strWeekTime, "): converting htm to csv..." );
	if ( !ConvertHTMtoCSV( WeekTime, strHTM, strCSV ) )
	{
		Print( "LoadWeek(", strWeekTime, "): converting error!" );
		return(false);
	}


	Print( "LoadWeek(", strWeekTime, "): writing csv..." );
	file_handle = FileOpen( FileName + ".csv", FILE_WRITE | FILE_CSV );
	if ( file_handle > 0 )
	{
		FileWrite( file_handle, strCSV );
		FileClose( file_handle );
	}
	else
	{
		_GetLastError = GetLastError();
		Print( "LoadWeek() - FileOpen() Error #", _GetLastError, "!" );
		return(false);
	}

	Print( "LoadWeek(", strWeekTime, "): OK!" );
	return(true);
}

//+------------------------------------------------------------------+
//|  htm  csv-
//+------------------------------------------------------------------+
bool ConvertHTMtoCSV( datetime StartWeekTime, string htm, string& csv )
{
	// <table id="weekdays" -  
	// </table> -  
	// class="alt1 -   , class="alt2 - 
	// <tr -  
	// <td class="alt -  
	int table_start	= StringFind( htm, "<table id=\"weekdays\"", 0 );
	int table_end		= StringFind( htm, "</table>", table_start+1 );
	if ( table_start < 0 || table_end < 0 )
	{
		Alert( "ConvertHTMtoCSV(", TimeToStr( StartWeekTime, TIME_DATE ), "): invalid htm format!" );
		return(false);
	}

	int		curr_row		= StringFind( htm, "<tr", table_start );
				curr_row		= StringFind( htm, "<tr", curr_row + 1 ); //   
	int		next_row		= StringFind( htm, "</tr>", curr_row + 1 );

	int		rows_count	= 0;
	string	rows			[999];

	while ( curr_row >= 0 && curr_row < table_end )
	{
		rows[rows_count] = StringSubstr( htm, curr_row, next_row - curr_row + 5 );
		rows_count ++;

		curr_row = StringFind( htm, "<tr", curr_row + 1 );
		next_row = StringFind( htm, "</tr>", curr_row + 1 );
	}

	if ( rows_count <= 0 )
	{
		Alert( "ConvertHTMtoCSV(", TimeToStr( StartWeekTime, TIME_DATE ), "): invalid htm format (no rows in table)!" );
		return(false);
	}

	datetime		curDayTime	= StartWeekTime;
	int			preRowMode	= 1;

	for ( int r = 0; r < rows_count; r ++ )
	{
		int curRowMode = 0;
		if ( StringFind( rows[r], "class=\"alt1", 0 ) >= 0 )
		{
			curRowMode = 1;
		}
		else if ( StringFind( rows[r], "class=\"alt2", 0 ) >= 0 )
		{
			curRowMode = 2;
		}

		if ( curRowMode != preRowMode )
		{
			curDayTime += DAY_SECONDS;
			preRowMode = curRowMode;
		}

		int		columns_count	= 0;
		string	columns			[999];

		int curr_col = StringFind( rows[r], "<td class=\"alt", 0 );
		int next_col = StringFind( rows[r], "</td>", curr_col+1 );

		while ( curr_col >= 0 )
		{
			columns[columns_count] = StringSubstr( rows[r], curr_col, next_col - curr_col + 5 );
			columns_count ++;

			curr_col = StringFind( rows[r], "<td class=\"alt", curr_col+1 );
			next_col = StringFind( rows[r], "</td>", curr_col+1 );
		}

		if ( columns_count > 6 )
		{
			csv = StringConcatenate( csv, TimeToStr( curDayTime, TIME_DATE ) );

//			if ( StringFind( columns[0], "padding-top: 2px;\">" ) > 0 )
//				csv = StringConcatenate( csv, ";", ConvertTimeTo24( GetVal( columns[0], "padding-top: 2px;\">", "</span>" ) ) );
			if ( StringFind( columns[0], "> " ) > 0 )
				csv = StringConcatenate( csv, ";", ConvertTimeTo24( GetVal( columns[0], "> ", "</span>" ) ) );
			else if ( StringFind( columns[0], "padding-top: 2px\">" ) > 0 )
				csv = StringConcatenate( csv, ";", ConvertTimeTo24( GetVal( columns[0], "padding-top: 2px\">", "</span>" ) ) );
			else
				csv = StringConcatenate( csv, ";", ConvertTimeTo24( GetVal( columns[0], "<span class=\"smallfont\">", "</span>" ) ) );

			csv = StringConcatenate( csv, ";", GetVal( columns[1], "<span class=\"smallfont\">", "</span>" ) );

			string impact = GetVal( columns[2], "title=\"", "\"></div>" );
			if ( impact == "High Impact Expected" )
				csv = StringConcatenate( csv, ";", "H" );
			else if ( impact == "Medium Impact Expected" )
				csv = StringConcatenate( csv, ";", "M" );
			else if ( impact == "Low Impact Expected" )
				csv = StringConcatenate( csv, ";", "L" );
			else
				csv = StringConcatenate( csv, ";", "N" );

			
			if ( StringFind( columns[5], "11px;\">" ) > 0 )
				csv = StringConcatenate( csv, ";", GetVal( columns[3], "x;\">", "</div>" ) );
			else
				csv = StringConcatenate( csv, ";", GetVal( columns[3], "x\">", "</div>" ) );


			if ( StringFind( columns[5], "Refresh for Actual Release" ) > 0 )
			{
				csv = StringConcatenate( csv, ";", "=" );
				csv = StringConcatenate( csv, ";", "" );
			}
			else
			{
				if ( StringFind( columns[5], "better" ) > 0 )
				{
					csv = StringConcatenate( csv, ";", ">" );
					csv = StringConcatenate( csv, ";", GetVal( columns[5], "<div class=\"smallfont\"><span class=\"better\">", "</span>" ) );
				}
				else if ( StringFind( columns[5], "worse" ) > 0 )
				{
					csv = StringConcatenate( csv, ";", "<" );
					csv = StringConcatenate( csv, ";", GetVal( columns[5], "<div class=\"smallfont\"><span class=\"worse\">", "</span>" ) );
				}
				else
				{
					csv = StringConcatenate( csv, ";", "=" );
					csv = StringConcatenate( csv, ";", GetVal( columns[5], "<div class=\"smallfont\"><span class=\"\">", "</span>" ) );
				}
			}

			csv = StringConcatenate( csv, ";", GetVal( columns[6], "<span class=\"smallfont\">", "</span>" ) );

			if ( StringFind( columns[7], "Revised From" ) > 0 )
			{
				string RevisedFrom = GetVal( columns[7], "title=\"Revised From ", "\">" );
				if ( StringFind( columns[7], "better" ) > 0 )
				{
					csv = StringConcatenate( csv, ";", ">" );
				}
				else if ( StringFind( columns[7], "worse" ) > 0 )
				{
					csv = StringConcatenate( csv, ";", "<" );
				}
				else
				{
					csv = StringConcatenate( csv, ";", "=" );
				}
				csv = StringConcatenate( csv, ";", GetVal( columns[7], "title=\"Revised From " + RevisedFrom + "\">", "<img src=" ) );
			}
			else
			{
				csv = StringConcatenate( csv, ";", "=" );
				csv = StringConcatenate( csv, ";", GetVal( columns[7], "<div class=\"smallfont\">", "</div>" ) );
			}

			csv = StringConcatenate( csv, ";\n" );
		}
	}
	return(true);
}

string GetVal( string text, string s_from, string s_to )
{
	int len  = StringLen( s_from );
	int pos1 = StringFind( text, s_from, 0 );
	int pos2 = StringFind( text, s_to, pos1+1 );

	if ( pos2 == pos1 + len )
	{
		return("");
	}
	else
	{
		if ( pos1 >= 0 && pos2 >= 0 )
		{
			string res = StringSubstr( text, pos1 + len, pos2 - (pos1 + len) );
			if ( StringFind( res, "&lt" ) >= 0 ) res = StringReplace( res, "&lt", "<" );
			return( res );
		}
		else
			return("GetValError");
	}
}

string ConvertTimeTo24( string time_am_pm )
{
	string time_24 = ""; int hours = 0;
	if ( StringFind( time_am_pm, "am" ) > 0 )
	{
		time_24 = StringSubstr( time_am_pm, 0, StringFind( time_am_pm, "am" ) );

		hours = StrToInteger( StringSubstr( time_24, 0, StringFind( time_am_pm, ":" ) ) );
		if ( hours > 11 ) hours -= 12;
		time_24 = StringConcatenate( hours, ":", StringSubstr( time_24, StringFind( time_am_pm, ":" )+1 ) );

		if ( StringLen( time_24 ) < 5 ) time_24 = "0" + time_24;
		return(time_24);
	}
	else if ( StringFind( time_am_pm, "pm" ) > 0 )
	{
		time_24 = StringSubstr( time_am_pm, 0, StringFind( time_am_pm, "pm" ) );

		hours = StrToInteger( StringSubstr( time_24, 0, StringFind( time_am_pm, ":" ) ) );
		if ( hours < 12 ) hours += 12;
		time_24 = StringConcatenate( hours, ":", StringSubstr( time_24, StringFind( time_am_pm, ":" )+1 ) );

		if ( StringLen( time_24 ) < 5 ) time_24 = "0" + time_24;
		return(time_24);
	}
	else
	{
		return(time_am_pm);
	}
}

string StringReplace( string InputString, string MatchedText, string NewText )
{
	string res;
	string temp,source;
	string first,third;
	int pos,matchLength,k;
	source=InputString;
	NewText=NewText;

	matchLength=StringLen(MatchedText);
	k=0;
	while (StringFind(source,MatchedText)!=-1)
 	{
 		pos=StringFind(source,MatchedText);
 		if (pos!=-1)
    	{
    		if (pos!=0)first=StringSubstr(source,0,pos); else first="";
    		third=StringSubstr(source,pos+matchLength,StringLen(source)-pos-matchLength);
    		temp=StringConcatenate(first,NewText,third);
    		source=temp;
    		k++;
    		if (k>2000) break;
    	}
 	}
	res=source; 
	return(res); 
}


void obj_delete( string prefix )
{
	int obj_total = ObjectsTotal(); string name;
	for ( int i = obj_total-1; i >= 0; i -- )
	{
		name = ObjectName(i);
		if ( StringFind( name, prefix ) == 0 ) ObjectDelete( name );
	}
}


//+---------------------------------------------------------------------------+
//|                                                               WinInet.mqh |
//|                                                        Paul Hampton-Smith |
//|                                                        paul1000@pobox.com |
//|                                                                           |
//| This include has been adapted from the groundbreaking GrabWeb script      |
//| developed by Adbi that showed me how to import functions from wininet.dll |
//|---------------------------------------------------------------------------|
//|                                                               grabweb.mq4 |
//|                                                    Copyright  2006, Abhi |
//|                                         http://www.megadelfi.com/experts/ |
//|                                     E-mail: grabwebexpert{Q)megadelfi.com |
//|                                fix my e-mail address before mailing me ;) |
//+---------------------------------------------------------------------------+
// Main Webscraping function
// ~~~~~~~~~~~~~~~~~~~~~~~~~
// bool GrabWeb(string strUrl, string& strWebPage)
// returns the text of any webpage. Returns false on timeout or other error
bool bWinInetDebug = false;

int hSession_IEType;
int hSession_Direct;
int Internet_Open_Type_Preconfig = 0;
int Internet_Open_Type_Direct = 1;
int Internet_Open_Type_Proxy = 3;
int Buffer_LEN = 80;

#define INTERNET_FLAG_PRAGMA_NOCACHE    0x00000100 // Forces the request to be resolved by the origin server, even if a cached copy exists on the proxy.
#define INTERNET_FLAG_NO_CACHE_WRITE    0x04000000 // Does not add the returned entity to the cache. 
#define INTERNET_FLAG_RELOAD            0x80000000 // Forces a download of the requested file, object, or directory listing from the origin server, not from the cache.
#define INTERNET_FLAG_NO_COOKIES			 0x00080000 // Does not automatically add cookie headers to requests, and does not automatically add returned cookies to the cookie database.

#import "wininet.dll"
	int InternetOpenA(
		string 	sAgent,
		int		lAccessType,
		string 	sProxyName="",
		string 	sProxyBypass="",
		int 	lFlags=0
	);
	int InternetOpenUrlA(
		int 	hInternetSession,
		string 	sUrl, 
		string 	sHeaders="",
		int 	lHeadersLength=0,
		int 	lFlags=0,
		int 	lContext=0 
	);
	int InternetReadFile(
		int 	hFile,
		string 	sBuffer,
		int 	lNumBytesToRead,
		int& 	lNumberOfBytesRead[]
	);
	int InternetCloseHandle(
		int 	hInet
	);
#import


bool GrabWeb(string strUrl, string& strWebPage)
{
	int 		hInternet;
	int		iResult;
	int 		lReturn[]	= {1};
	string 	sBuffer		= "                                                                                                                                                                                                                                                               ";	// 255 spaces
	int 		bytes;
	
	hInternet = InternetOpenUrlA(hSession(FALSE), strUrl, "0", 0, 
								INTERNET_FLAG_NO_CACHE_WRITE | 
								INTERNET_FLAG_PRAGMA_NOCACHE | 
								INTERNET_FLAG_RELOAD			  |
								INTERNET_FLAG_NO_COOKIES, 0);

	if (bWinInetDebug) 
		Print("hInternet: " + hInternet);   
	if (hInternet == 0) 
		return(false);

//	Print("Reading URL: " + strUrl);	   //added by MN	
	iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
	
	if (bWinInetDebug) 
		Print("iResult: " + iResult);
	if (bWinInetDebug) 
		Print("lReturn: " + lReturn[0]);
	if (bWinInetDebug) 
		Print("iResult: " + iResult);
	if (bWinInetDebug) 
		Print("sBuffer: " +  sBuffer);
	if (iResult == 0) 
		return(false);
	bytes = lReturn[0];

	strWebPage = StringSubstr(sBuffer, 0, lReturn[0]);
	
	// If there's more data then keep reading it into the buffer
	while (lReturn[0] != 0)
	{
		iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
		if (lReturn[0]==0) 
			break;
		bytes = bytes + lReturn[0];
		strWebPage = strWebPage + StringSubstr(sBuffer, 0, lReturn[0]);
	}

//	Print("Closing URL web connection");   //added by MN
	iResult = InternetCloseHandle(hInternet);
	if (iResult == 0) 
		return(false);
		
	return(true);
}

int hSession(bool Direct)
{
	string InternetAgent;
	if (hSession_IEType == 0)
	{
		InternetAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461)";
		hSession_IEType = InternetOpenA(InternetAgent, Internet_Open_Type_Preconfig, "0", "0", 0);
		hSession_Direct = InternetOpenA(InternetAgent, Internet_Open_Type_Direct, "0", "0", 0);
	}
	if (Direct) 
	{ 
		return(hSession_Direct); 
	}
	else 
	{
		return(hSession_IEType); 
	}
}

